local GhostList = {};

addHook("MobjSpawn", function(ghost)
	if (modeattacking and leveltime < 2)
		// a time attack ghost
		ghost.recordAttackGhost = true;
	end

	// insert into ghosts with animators list
	table.insert(GhostList, ghost);
	ghost.flags2 = $1 | MF2_DONTDRAW;
end, MT_GHOST)

Gamma.RunGhost = function(ghost)
	if not (ghost.gammaFollow and ghost.gammaFollow.valid)
		// create an animator for the ghost
		ghost.gammaFollow = P_SpawnMobjFromMobj(ghost, 0, 0, 0, MT_GAMMA_ANIMATIONMASTER);
		ghost.gammaFollow.tracer = ghost;
		ghost.gammaFollow.flags2 = $1 | MF2_LINKDRAW;

		if not (ghost.recordAttackGhost)
			ghost.gammaFollowSPR2 = ghost.sprite2;
		end
	end

	if (ghost.gammaFollowSPR2 != nil)
		ghost.sprite2 = ghost.gammaFollowSPR2;
	end

	if (ghost.flags2 & MF2_DONTDRAW)
		P_SetOrigin(ghost.gammaFollow, ghost.x, ghost.y, ghost.z);
	end

	// run the animator for the ghost
	ghost.flags2 = $1 & ~MF2_DONTDRAW;
	Gamma.FollowMobj(ghost, ghost.gammaFollow);
	ghost.sprite2 = SPR2_STND;
end

local function IsGammaGhost(ghost)
	if (ghost.gammaFollow and ghost.gammaFollow.valid)
		-- We've already established this is definitely a gamma ghost
		return true;
	end

	if (ghost.sprite != SPR_PLAY)
		return false;
	end

	return (ghost.skin == "gamma");
end

Gamma.RunRecordAttackGhosts = function()
	/*
	if not (modeattacking)
		// IGNORE
		return;
	end

	if (leveltime < 2)
		// wait a bit...
		return;
	end
	*/

	for k,ghost in pairs(GhostList) do
		if not (ghost and ghost.valid)
			table.remove(GhostList, k);
			continue;
		end

		if (IsGammaGhost(ghost) == false)
			-- Doesn't look like a gamma ghost
			ghost.flags2 = $1 & ~MF2_DONTDRAW;
			table.remove(GhostList, k);
			continue;
		end

		Gamma.RunGhost(ghost);
	end
end
