//
// Gamma Persona support
//

charStats["gamma"] = {
	name = "E-102 Gamma",
	basehp = 60,
	basesp = 50,
	persona = "gamma",
	overlay = MT_GAMMA_ANIMATIONMASTER,
	overlaythink = function(mo)
		mo.tracer = mo.target;
		-- The rest is handled by MT_GAMMA_ANIMATIONMASTER thinker
	end,

	wep = "gamma rifle",
	weptype = WPT_GENERICRANGED,
	melee_natk = "gamma attack",

	atk = 45,
	acc = 999,
	crit = 5,

	anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},		-- standing
	anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},		-- standing (low HP)
	anim_stand_bored =	{SPR_PLAY, A, B, A, B, A, B, A, B, 10, "SPR2_WAIT"},	-- standing (rare anim)
	anim_guard = 		{SPR_PLAY, A, 1, "SPR2_WALK"},		-- guarding
	anim_move =			{SPR_PLAY, A, B, C, D, E, F, G, H, 2, "SPR2_WALK"},		-- moving
	anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},	-- guess what
	anim_atk =			{SPR_PLAY, A, B, C, D, 1, "SPR2_RUN_"},	-- attacking
	anim_aoa_end =		{SPR_PLAY, D, C, B, A, 1, "SPR2_ROLL"},	-- jumping out of all-out attack
	anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},		-- taking damage
	anim_getdown =		{SPR_PLAY, A, 1, "SPR2_PAIN"},		-- knocked down from weakness / crit
	anim_downloop =		{SPR_PLAY, A, 1, "SPR2_PAIN"},		-- is down
	anim_getup =		{SPR_PLAY, A, B, C, D, 1, "SPR2_RUN_"},		-- gets up from down
	anim_death =		{SPR_PLAY, A, 30, "SPR2_PAIN"},		-- dies
	anim_revive =		{SPR_PLAY, A, B, C, D, 1, "SPR2_RUN_"},		-- gets revived

	icon = "E102PICO",
	hudbust = "E102PBAR",
	hudaoa = "E102PAOA",
	hudcutin = "E102PCUT",
	aoa_quote = "Target acquired. Requesting permission to save.",

	tip = "Has powerful base stats and skills.\n" ..
		"However, they are under constant\n" ..
		"pressure from losing HP every turn.\n" ..
		"They will need extra attention from\n" ..
		"from a healer to properly shine.",
};

personaList["gamma"] = {
    name = "E-102 Gamma",
    arcana = ARCANA_TEMPERANCE,

    anim_idle = 	{SPR_NULL, A},
	anim_atk = 		{SPR_NULL, A},

	weak = ATK_NUCLEAR,
	resist = ATK_STRIKE|ATK_ELEC,

    strength = 10,
    magic = 12,
    endurance = 11,
    luck = 6,
    agility = 8,

    skills = {
		{"time limit", 1},
		{"target bonus", 1},
    },
};

attackDefs["gamma attack"] = {
	name = "Lock-On Missiles",
	type = ATK_NUCLEAR,
	power = 40,
	accuracy = 999,
	critical = 3,
	target = TGT_ENEMY,
	costtype = CST_SP,
	cost = 0,
	desc = "Attack a target with\n" ..
			"a lock-on missile",
	physical = true,
	anim = function(mo, targets, hittargets, timer)
		local target = hittargets[1];
		local time = timer;

		if (time == 20)
			damageObject(target);
		end

		if (timer == 60 + 10)
			return true;
		end
	end,
};

attackDefs["time limit"] = {
	name = "Time Limit",
	type = ATK_PASSIVE|ATK_CURSE,
	desc = "HP reduces by 10% each turn.",
	passive = PSV_STARTTURN,
	anim = function(mo, targets, hittargets, timer)
		damageObject(mo, max(1, mo.maxhp * 10 / 100), DMG_NORMAL);
		mo.gammaPersonaCombo = nil; // Reset this here too
		return true;
	end
};

attackDefs["target bonus"] = {
	name = "Target Bonus",
	type = ATK_PASSIVE|ATK_BLESS,
	desc = "Gain HP dealing final blows.\n" ..
			"More in one turn adds extra.",
	passive = PSV_TRIGGERDAMAGE,
	anim = function(attacker, target, damage, crit)
		if (target.hp <= damage) then
			if (attacker.gammaPersonaCombo == nil)
				attacker.gammaPersonaCombo = 0;
			end
			attacker.gammaPersonaCombo = $1 + 1;

			// extremely hilarious function reuse
			local percent = Gamma.ComboToSeconds(attacker.gammaPersonaCombo) * 5;
			if (percent > 100)
				percent = 100;
			end

			damageObject(attacker, -(mo.maxhp * percent / 100), DMG_NORMAL);
		end
	end
};

weaponsList["gamma rifle"] = {
	name = "Laser Rifle",
	type = WPT_GENERICRANGED,
	atk = 400,
	desc = "E-Series' standard issue\nrapid lock-on launcher.",
	slot = "mastery 1",
	rarity = 1,
};

weaponsList["gamma blaster"] = {
	name = "Laser Blaster",
	type = WPT_GENERICRANGED,
	atk = 1600,
	desc = "Upgraded E-Series launcher,\ncapable of splash damage.",
	slot = "mastery 3",
	rarity = 5,
};
